﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace RichTextBoxExample
{
    public class rtbAdd
    {
        public delegate void EmptyDelegate();

        public rtbAdd(System.Windows.Forms.RichTextBox r, params object[] o)
        {
            process(r, o);
        }

        void process(System.Windows.Forms.RichTextBox r, params object[] o)
        {
            string TimeStamp = string.Format("[{0}] ", DateTime.Now.ToLongTimeString());
            if (r.InvokeRequired)
            {
                EmptyDelegate del1 = delegate()
                {
                    process(r, o);
                };
                r.Invoke(del1);
            }
            else
            {
                r.SelectionStart = r.TextLength;
                r.SelectionLength = 0;
                r.SelectionColor = Color.White;
                r.SelectedText = TimeStamp;
                for (int i = 0; i != o.Length; i += 2)
                {
                    r.SelectionStart = r.TextLength;
                    r.SelectionLength = 0;
                    r.SelectionColor = (System.Drawing.Color)o[i];
                    if (i == (o.Length - 2))
                    {
                        r.SelectedText = (string)o[i + 1] + Environment.NewLine;
                    }
                    else
                    {
                        r.SelectedText = (string)o[i + 1];
                    }

                }
                if (r.Lines.Length >= 500)
                {
                    r.SelectionStart = 0;
                    r.SelectionLength = r.Text.IndexOf('\n') + 1;
                    r.SelectedText = " ";
                    r.SelectionStart = 0;
                    r.SelectionLength = r.Text.IndexOf(']');
                    r.SelectedText = r.SelectedText.Substring(1);
                }
                r.SelectionStart = r.Text.Length;
                r.ScrollToCaret();
            }
        }
    }
}
